<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE sect1 PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
   "http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
  <!ENTITY % general-entities SYSTEM "../../general.ent">
  %general-entities;


  <!ENTITY mariadb-download-http "https://downloads.mariadb.org/interstitial/mariadb-&mariadb-version;/source/mariadb-&mariadb-version;.tar.gz">
  <!ENTITY mariadb-download-ftp  " ">
  <!ENTITY mariadb-md5sum        "49a28cc68710e0e3b030e90579eec7db">
  <!ENTITY mariadb-size          "107 MB">
  <!ENTITY mariadb-buildsize     "2.8 GB (745 MB installed)">
  <!ENTITY mariadb-time          "5.1 SBU (with parallelism=8, add 0.3 SBU for tests)">
]>

<sect1 id="mariadb" xreflabel="MariaDB-&mariadb-version;">
  <?dbhtml filename="mariadb.html"?>


  <title>MariaDB-&mariadb-version;</title>

  <indexterm zone="mariadb">
    <primary sortas="a-MariaDB">MariaDB</primary>
  </indexterm>

  <sect2 role="package">
    <title>Introduction to MariaDB</title>

    <para>
      <application>MariaDB</application> is a community-developed fork and a
      drop-in replacement for the <application>MySQL</application> relational
      database management system.
    </para>

    &lfs122_checked;

    <bridgehead renderas="sect3">Package Information</bridgehead>
    <itemizedlist spacing="compact">
      <listitem>
        <para>
          Download (HTTP): <ulink url="&mariadb-download-http;"/>
        </para>
      </listitem>
      <listitem>
        <para>
          Download (FTP): <ulink url="&mariadb-download-ftp;"/>
        </para>
      </listitem>
      <listitem>
        <para>
          Download MD5 sum: &mariadb-md5sum;
        </para>
      </listitem>
      <listitem>
        <para>
          Download size: &mariadb-size;
        </para>
      </listitem>
      <listitem>
        <para>
          Estimated disk space required: &mariadb-buildsize;
        </para>
      </listitem>
      <listitem>
        <para>
          Estimated build time: &mariadb-time;
        </para>
      </listitem>
    </itemizedlist>

    <note>
      <para>
        The installed size of MariaDB is 745 MB, but this can be
        reduced by about 265 MB, if desired, by removing the <filename
        class="directory">/usr/share/mariadb/test</filename>
        directory after installation.
      </para>
    </note>

    <bridgehead renderas="sect3">MariaDB Dependencies</bridgehead>

    <bridgehead renderas="sect4">Required</bridgehead>
    <para role="required">
      <xref linkend="cmake"/>
    </para>

    <bridgehead renderas="sect4">Recommended</bridgehead>
    <para role="recommended">
      <xref linkend="libevent"/>
    </para>

    <bridgehead renderas="sect4">Optional</bridgehead>
    <para role="optional">
      <xref linkend="boost"/>,
      <xref linkend="libaio"/>,
      <xref linkend="libxml2"/>,
      <xref linkend="linux-pam"/>,
      <xref linkend="lzo"/>,
      <xref linkend="mitkrb"/>,
      <xref linkend="pcre2"/>,
      <xref linkend="ruby"/>,
      <xref linkend="sphinx"/>,
      <xref linkend="unixodbc"/>,
      <xref linkend="valgrind"/>,
      <ulink url="https://groonga.org/">Groonga</ulink>,
      <ulink url="https://www.phontron.com/kytea/">KyTea</ulink>,
      <ulink url="https://sourceforge.net/projects/judy/">Judy</ulink>,
      <ulink url="https://taku910.github.io/mecab">MeCab</ulink>,
      <ulink url="https://msgpack.org/">MessagePack</ulink>,
      <ulink url="https://www.mruby.org/">mruby</ulink>,
      <ulink url="https://mariadb.com/kb/en/myrocks/">MyRocks</ulink>,
      <ulink url="https://github.com/google/snappy">Snappy</ulink>, and
      <ulink url="https://zeromq.org/">ZeroMQ</ulink>
    </para>

  </sect2>

  <sect2 role="installation">
    <title>Installation of MariaDB</title>

    <warning>
      <para>
        MariaDB and MySQL cannot be installed on the same system without
        extensive changes to the build configuration of one of the two applications.
      </para>
    </warning>

    <para>
      For security reasons, running the server as an unprivileged user
      and group is strongly encouraged. Issue the following (as
      <systemitem class="username">root</systemitem>) to create the
      user and group:
    </para>

<screen role="root"><userinput>groupadd -g 40 mariadb &amp;&amp;
useradd -c "MariaDB Server" -d /srv/mariadb -g mariadb -s /bin/false -u 40 mariadb</userinput></screen>

    <para>
      Install <application>MariaDB</application> by running the
      following commands:
    </para>

<screen><userinput>mkdir build &amp;&amp;
cd    build &amp;&amp;

cmake -D CMAKE_BUILD_TYPE=Release                       \
      -D CMAKE_INSTALL_PREFIX=/usr                      \
      -D GRN_LOG_PATH=/var/log/groonga.log              \
      -D INSTALL_DOCDIR=share/doc/mariadb-&mariadb-version;        \
      -D INSTALL_DOCREADMEDIR=share/doc/mariadb-&mariadb-version;  \
      -D INSTALL_MANDIR=share/man                       \
      -D INSTALL_MYSQLSHAREDIR=share/mariadb            \
      -D INSTALL_MYSQLTESTDIR=share/mariadb/test        \
      -D INSTALL_PAMDIR=lib/security                    \
      -D INSTALL_PAMDATADIR=/etc/security               \
      -D INSTALL_PLUGINDIR=lib/mariadb/plugin           \
      -D INSTALL_SBINDIR=sbin                           \
      -D INSTALL_SCRIPTDIR=bin                          \
      -D INSTALL_SQLBENCHDIR=share/mariadb/bench        \
      -D INSTALL_SUPPORTFILESDIR=share/mariadb          \
      -D MYSQL_DATADIR=/srv/mariadb                     \
      -D MYSQL_UNIX_ADDR=/run/mariadb/mariadb.sock      \
      -D WITH_EXTRA_CHARSETS=complex                    \
      -D WITH_EMBEDDED_SERVER=ON                        \
      -D SKIP_TESTS=ON                                  \
      -D TOKUDB_OK=0                                    \
      .. &amp;&amp;
make</userinput></screen>

    <para>
      To test the results, issue: <command>make test</command>.
      Two tests, my_tzinfo and test-connect, are known to fail.
    </para>

    <note><para>
      A more extensive set of tests can be run with the following:</para>

<screen remap="test"><userinput>pushd mysql-test
./mtr --parallel <replaceable>&lt;N&gt;</replaceable> --mem --force
popd</userinput></screen>

    <para>
      Where N is the number of tests to run in parallel.
      Over 5400 tests are run in about 24 SBU with N=4.  A few tests
      may fail, mainly due to character set issues.
    </para></note>

    <para>
      Now, as the <systemitem class="username">root</systemitem> user:
    </para>

<screen role="root"><userinput>make install</userinput></screen>
<!--
    <para>
      If you have <xref linkend="linux-pam" role="nodep"/> installed, move the
      PAM module and configuration file installed by this package as the
      &root; user:
    </para>

<screen role="nodump"><userinput>mv -v /usr/share/pam_use_map.so /lib/security &amp;&amp;
mv -v /usr/share/user_map.conf /etc/security</userinput></screen>
-->
  </sect2>

  <sect2 role="commands">
    <title>Command Explanations</title>

    <para>
      <parameter>-D WITH_EMBEDDED_SERVER=ON</parameter>: This switch enables
      compiling the embedded server library needed by certain applications,
      such as <application>Amarok</application>.
    </para>

    <para>
      <parameter>-D WITH_EXTRA_CHARSETS=complex</parameter>: This switch enables
      support for the complex character sets.
    </para>

    <para>
      <parameter>-D SKIP_TESTS=ON</parameter>: This switch disables
      tests for MariaDB Connector/C which are not supported without
      additional setup.
    </para>

    <para>
      <option>-D WITHOUT_SERVER=ON</option>: Use this
      switch if you don't want the server and would like to build the client
      only.
    </para>

    <note><para>
      There are numerous options available to <command>cmake</command>. Check
      the output of the <command>cmake . -LH</command> for additional
      customization options.
    </para></note>

  </sect2>

  <sect2 role="configuration">
    <title>Configuring MySQL</title>

    <sect3 id="mariadb-config">
      <title>Config Files</title>

      <para>
        <filename>/etc/mariadb/my.cnf</filename> and
        <filename>~/.my.cnf</filename>
      </para>

      <indexterm zone="mariadb mariadb-config">
        <primary sortas="e-AA.my.cnf">~/.my.cnf</primary>
      </indexterm>

      <indexterm zone="mariadb mariadb-config">
        <primary sortas="e-etc-mariadb-my.cnf">/etc/mariadb/my.cnf</primary>
      </indexterm>

    </sect3>

    <sect3>
      <title>Configuration Information</title>

      <para>
        Create a basic <filename>/etc/mariadb/my.cnf</filename>
        file using the following command as the <systemitem
        class="username">root</systemitem> user:
      </para>

<screen role="root"><userinput>install -v -dm 755 /etc/mariadb &amp;&amp;
cat &gt; /etc/mariadb/my.cnf &lt;&lt; "EOF"
<literal># Begin /etc/mariadb/my.cnf

# The following options will be passed to all MySQL clients
[client]
#password       = your_password
port            = 3306
socket          = /run/mariadb/mariadb.sock

# The MySQL server
[mariadb]
port            = 3306
socket          = /run/mariadb/mariadb.sock
datadir         = /srv/mariadb
skip-external-locking
key_buffer_size = 16M
max_allowed_packet = 1M
sort_buffer_size = 512K
net_buffer_length = 16K
myisam_sort_buffer_size = 8M

# Don't listen on a TCP/IP port at all.
skip-networking

# required unique id between 1 and 2^32 - 1
server-id       = 1

# Uncomment the following if you are using BDB tables
#bdb_cache_size = 4M
#bdb_max_lock = 10000

# InnoDB tables are now used by default
innodb_data_home_dir = /srv/mariadb
innodb_log_group_home_dir = /srv/mariadb
# All the innodb_xxx values below are the default ones:
innodb_data_file_path = ibdata1:12M:autoextend
# You can set .._buffer_pool_size up to 50 - 80 %
# of RAM but beware of setting memory usage too high
innodb_buffer_pool_size = 128M
innodb_log_file_size = 48M
innodb_log_buffer_size = 16M
innodb_flush_log_at_trx_commit = 1
innodb_lock_wait_timeout = 50

[mariadbdump]
quick
max_allowed_packet = 16M

[mariadb]
no-auto-rehash
# Remove the next comment character if you are not familiar with SQL
#safe-updates

[isamchk]
key_buffer = 20M
sort_buffer_size = 20M
read_buffer = 2M
write_buffer = 2M

[myisamchk]
key_buffer_size = 20M
sort_buffer_size = 20M
read_buffer = 2M
write_buffer = 2M

[mariadbhotcopy]
interactive-timeout

# End /etc/mariadb/my.cnf</literal>
EOF</userinput></screen>

      <para>
        You can now install a database and change the ownership to the
        unprivileged user and group (perform as the <systemitem
        class="username">root</systemitem> user):
      </para>

<screen role="root"><userinput>mariadb-install-db --basedir=/usr --datadir=/srv/mariadb --user=mariadb &amp;&amp;
chown -R mariadb:mariadb /srv/mariadb</userinput></screen>

      <para>
        Further configuration requires that the
        <application>MariaDB</application> server is running. Start
        the server using the following commands as the <systemitem
        class="username">root</systemitem> user:
      </para>

<screen role="root"><userinput>install -v -m755 -o mariadb -g mariadb -d /run/mariadb &amp;&amp;
mariadbd-safe --user=mariadb 2&gt;&amp;1 &gt;/dev/null &amp;</userinput></screen>

      <para>
        A default installation does not set up a password for the
        administrator, so use the following command as the <systemitem
        class="username">root</systemitem> user to set one.
      </para>

<screen role="root"><userinput>mariadb-admin -u root password</userinput></screen>

      <para>
        Configuration of the server is now finished. Shut the server
        down using the following command as the <systemitem
        class="username">root</systemitem> user:
      </para>

<screen role="root"><userinput>mariadb-admin -p shutdown</userinput></screen>

    </sect3>

    <sect3 id="mariadb-init">
      <title><phrase revision="sysv">Boot Script</phrase>
             <phrase revision="systemd">Systemd Unit</phrase></title>

      <para>
        Install the
        <phrase revision="sysv"><filename>/etc/rc.d/init.d/mariadb</filename> init
        script</phrase>
        <phrase revision="systemd"><filename>mariadb.service</filename>
        unit</phrase> included in the
        <xref linkend="bootscripts" revision="sysv"/>
        <xref linkend="systemd-units" revision="systemd"/> package as
        the <systemitem class="username">root</systemitem> user to start the
        <application>MariaDB</application> server during system boot-up.
      </para>

      <indexterm zone="mariadb mariadb-init">
        <primary sortas="f-mariadb">mariadb</primary>
      </indexterm>

<screen role="root" revision="sysv"><userinput>make install-mariadb</userinput></screen>

<screen role="root" revision="systemd"><userinput>make install-mariadb</userinput></screen>

      <note>
        <para>
          If you have an existing database already and this
          installation of binaries was just an upgrade to a newer
          version, check the upstream documentation for upgrading. It
          is recommended to run:
          <screen role="nodump"><userinput>mariadb-upgrade</userinput></screen>
        </para>
      </note>
    </sect3>

  </sect2>

  <sect2 role="content">
    <title>Contents</title>

    <segmentedlist>
      <segtitle>Installed Programs</segtitle>
      <segtitle>Installed Libraries</segtitle>
      <segtitle>Installed Directories</segtitle>

      <seglistitem>
        <seg>
          aria_chk, aria_dump_log, aria_ftdump, aria_pack, aria_read_log,
          aria_s3_copy, galera_new_cluster, galera_recovery,
          innochecksum, mariabackup, mariadb, mariadbd, mariadb-access,
          mariadb-admin, mariadb-backup, mariadb-binlog, mariadb-check,
          mariadb-client-test, mariadb-client-test-embedded, mariadb-conv,
          mariadb-convert-table-format, mariadb-find-rows, mariadbd-multi,
          mariadbd-safe, mariadbd-safe-helper, mariadb-dump, mariadb-dumpslow,
          mariadb-embedded, mariadb-fix-extensions, mariadb-hotcopy,
          mariadb-import, mariadb-install-db, mariadb-ldb, mariadb-plugin,
          mariadb-secure-installation, mariadb-setpermission,
          mariadb-service-convert, mariadb-show,
          mariadb-slap, mariadb-test, mariadb-test-embedded,
          mariadb-tzinfo-to-sql, mariadb-upgrade, mariadb-waitpid,
          mariadb_config,
          mbstream, msql2mysql, my_print_defaults, myisamchk,
          myisam_ftdump, myisamlog, myisampack, mysql_config, mytop, perror,
          replace, resolve_stack_dump, resolveip, sst_dump, wsrep_sst_common,
          wsrep_sst_mariabackup, wsrep_sst_mysqldump, and wsrep_sst_rsync
        </seg>
        <seg>
          libmariadb.a,
          libmariadb.so,
          libmariadbclient.a,
          libmariadbd.a,
          libmariadbd.so,
          libmariadb.so.3,
          libmysqlclient.a,
          libmysqlclient.so,
          libmysqlclient_r.a,
          libmysqlclient_r.so,
          libmysqld.a,
          libmysqld.so,
          libmysqlservices.a, and
          about 70 modules under /usr/lib/mysql/plugin/
        </seg>
        <seg>
          /usr/{include,lib,share}/mysql,
          /usr/share/groonga{,-normalizer-mysql}, and
          /usr/share/doc/mariadb-&mariadb-version;
        </seg>
      </seglistitem>
    </segmentedlist>

    <bridgehead renderas="sect3">Short Descriptions</bridgehead>

    <para>
      There are several symlinks from mysql* to their mariadb
      counterparts. These are maintained for compatibility.
    </para>

<!--
    <para>
      Descriptions of all the programs and libraries would be several
      pages long. Instead, consult the man pages
      or the online documentation at <ulink
      url="https://mariadb.com/kb/en/mariadb-documentation/"/>.
    </para>
-->
    <para>
      The <application>Perl</application> DBI modules must be installed
      for some of the <application>MariaDB</application> support programs to
      function properly.
    </para>

    <variablelist>
      <bridgehead renderas="sect3">Short Descriptions</bridgehead>
      <?dbfo list-presentation="list"?>
      <?dbhtml list-presentation="table"?>

      <varlistentry id="aria_chk-mariadb">
        <term><command>aria_chk</command></term>
        <listitem>
          <para>
            is used to check, repair, optimize, sort and get information
            about Aria tables
          </para>
          <indexterm zone="mariadb aria_chk-mariadb">
            <primary sortas="b-aria_chk-mariadb">aria_chk</primary>
          </indexterm>
        </listitem>
      </varlistentry>

      <varlistentry id="aria_dump_log-mariadb">
        <term><command>aria_dump_log</command></term>
        <listitem>
          <para>
            is a tool to dump the contents of Aria log pages
          </para>
          <indexterm zone="mariadb aria_dump_log-mariadb">
            <primary sortas="b-aria_dump_log-mariadb">aria_dump_log</primary>
          </indexterm>
        </listitem>
      </varlistentry>

      <varlistentry id="aria_ftdump-mariadb">
        <term><command>aria_ftdump</command></term>
        <listitem>
          <para>
            displays full-text index information
          </para>
          <indexterm zone="mariadb aria_ftdump-mariadb">
            <primary sortas="b-aria_ftdump-mariadb">aria_ftdump</primary>
          </indexterm>
        </listitem>
      </varlistentry>

      <varlistentry id="aria_pack-mariadb">
        <term><command>aria_pack</command></term>
        <listitem>
          <para>
            is a tool to generate compressed, read-only Aria tables
          </para>
          <indexterm zone="mariadb aria_pack-mariadb">
            <primary sortas="b-aria_pack-mariadb">aria_pack</primary>
          </indexterm>
        </listitem>
      </varlistentry>

      <varlistentry id="aria_read_log-mariadb">
        <term><command>aria_read_log</command></term>
        <listitem>
          <para>
            displays Aria log file contents
          </para>
          <indexterm zone="mariadb aria_read_log-mariadb">
            <primary sortas="b-aria_read_log-mariadb">aria_read_log</primary>
          </indexterm>
        </listitem>
      </varlistentry>

      <varlistentry id="aria_s3_copy-mariadb">
        <term><command>aria_s3_copy</command></term>
        <listitem>
          <para>
            copies an aria table to and from AWS S3
          </para>
          <indexterm zone="mariadb aria_s3_copy-mariadb">
            <primary sortas="b-aria_s3_copy-mariadb">aria_s3_copy</primary>
          </indexterm>
        </listitem>
      </varlistentry>

      <varlistentry id="galera_new_cluster-mariadb">
         <term><command>galera_new_cluster</command></term>
         <listitem>
           <para>
             bootstraps a new Galera cluster
           </para>
           <indexterm zone="mariadb galera_new_cluster-mariadb">
             <primary sortas="b-galera_new_cluster-mariadb">galera_new_cluster</primary>
           </indexterm>
         </listitem>
      </varlistentry>

      <varlistentry id="galera_recovery-mariadb">
        <term><command>galera_recovery</command></term>
        <listitem>
          <para>
            recovers data from a Galera cluster
          </para>
          <indexterm zone="mariadb galera_recovery-mariadb">
             <primary sortas="b-galera_recovery-mariadb">galera_recovery</primary>
          </indexterm>
        </listitem>
      </varlistentry>

      <varlistentry id="innochecksum-mariadb">
        <term><command>innochecksum</command></term>
        <listitem>
          <para>
            prints checksums for InnoDB files
          </para>
          <indexterm zone="mariadb innochecksum-mariadb">
            <primary sortas="b-innochecksum-mariadb">innochecksum</primary>
          </indexterm>
        </listitem>
      </varlistentry>

      <varlistentry id="mariabackup-mariadb">
        <term><command>mariabackup</command></term>
        <listitem>
          <para>
            is an open source backup tool for InnoDB and XtraDB
          </para>
          <indexterm zone="mariadb mariabackup-mariadb">
            <primary sortas="b-mariabackup-mariadb">mariabackup</primary>
          </indexterm>
        </listitem>
      </varlistentry>

      <varlistentry id="mariadb-mariadb">
        <term><command>mariadb</command></term>
        <listitem>
          <para>
             is a simple SQL shell with input line editing capabilities
          </para>
          <indexterm zone="mariadb mariadb-mariadb">
            <primary sortas="b-mariadb-mariadb">mariadb</primary>
          </indexterm>
        </listitem>
      </varlistentry>

      <varlistentry id="mariadbd-mariadb">
        <term><command>mariadbd</command></term>
        <listitem>
          <para>
            is the MySQL server daemon
          </para>
          <indexterm zone="mariadb mariadbd-mariadb">
            <primary sortas="b-mariadbd-mariadb">mariadbd</primary>
          </indexterm>
        </listitem>
      </varlistentry>

      <varlistentry id="mariadb-access-mariadb">
        <term><command>mariadb-access</command></term>
        <listitem>
          <para>
            checks the access privileges for a host name, user name, and
            database combination
          </para>
          <indexterm zone="mariadb mariadb-access-mariadb">
            <primary sortas="b-mariadb-access-mariadb">mariadb-access</primary>
          </indexterm>
        </listitem>
      </varlistentry>

      <varlistentry id="mariadb-admin-mariadb">
        <term><command>mariadb-admin</command></term>
        <listitem>
          <para>
            is a client for performing administrative operations
          </para>
          <indexterm zone="mariadb mariadb-admin-mariadb">
            <primary sortas="b-mariadb-admin-mariadb">mariadb-admin</primary>
          </indexterm>
        </listitem>
      </varlistentry>

      <varlistentry id="mariadb-binlog-mariadb">
        <term><command>mariadb-binlog</command></term>
        <listitem>
          <para>
            reads binary log files
          </para>
          <indexterm zone="mariadb mariadb-binlog-mariadb">
            <primary sortas="b-mariadb-binlog-mariadb">mariadb-binlog</primary>
          </indexterm>
        </listitem>
      </varlistentry>

      <varlistentry id="mariadb-check-mariadb">
        <term><command>mariadb-check</command></term>
        <listitem>
          <para>
            performs table maintenance: It checks, repairs, optimizes,
            or analyzes tables
          </para>
          <indexterm zone="mariadb mariadb-check-mariadb">
            <primary sortas="b-mariadb-check-mariadb">mariadb-check</primary>
          </indexterm>
        </listitem>
      </varlistentry>

      <varlistentry id="mariadb-client-test-mariadb">
        <term><command>mariadb-client-test</command></term>
        <listitem>
          <para>
            is used for testing aspects of the MySQL client API that cannot be
            tested using mariadb-test and its test language
          </para>
          <indexterm zone="mariadb mariadb-client-test-mariadb">
            <primary sortas="b-mariadb-client-test-mariadb">mariadb-client-test</primary>
          </indexterm>
        </listitem>
      </varlistentry>

      <varlistentry id="mariadb-client-test-embedded-mariadb">
        <term><command>mariadb-client-test-embedded</command></term>
        <listitem>
          <para>
            is a tool to test the client API for the embedded server
          </para>
          <indexterm zone="mariadb mariadb-client-test-embedded-mariadb">
            <primary sortas="b-mariadb-client-test-embedded-mariadb">mariadb-client-test-embedded</primary>
          </indexterm>
        </listitem>
      </varlistentry>

      <varlistentry id="mariadb-conv-mariadb">
        <term><command>mariadb-conv</command></term>
        <listitem>
          <para>
            converts character sets for use with MariaDB
          </para>
          <indexterm zone="mariadb mariadb-conv-mariadb">
            <primary sortas="b-mariadb-conv-mariadb">mariadb-conv</primary>
          </indexterm>
        </listitem>
      </varlistentry>

      <varlistentry id="mariadb-convert-table-format-mariadb">
        <term><command>mariadb-convert-table-format</command></term>
        <listitem>
          <para>
            converts the tables in a database to use a particular storage
            engine
          </para>
          <indexterm zone="mariadb mariadb-convert-table-format-mariadb">
            <primary sortas="b-mariadb-convert-table-format-mariadb">mariadb-convert-table-format</primary>
          </indexterm>
        </listitem>
      </varlistentry>

      <varlistentry id="mariadbd-multi-mariadb">
        <term><command>mariadbd-multi</command></term>
        <listitem>
          <para>
            is designed to manage several mariadb processes that listen for
            connections on different Unix socket files and TCP/IP ports
          </para>
          <indexterm zone="mariadb mariadbd-multi-mariadb">
            <primary sortas="b-mariadbd-multi-mariadb">mariadbd-multi</primary>
          </indexterm>
        </listitem>
      </varlistentry>

      <varlistentry id="mariadbd-safe-mariadb">
        <term><command>mariadbd-safe</command></term>
        <listitem>
          <para>
             is the recommended way to start a mariadb server on Unix
             and NetWare
          </para>
          <indexterm zone="mariadb mariadbd-safe-mariadb">
            <primary sortas="b-mariadbd-safe-mariadb">mariadbd-safe</primary>
          </indexterm>
        </listitem>
      </varlistentry>

      <varlistentry id="mariadb-dump-mariadb">
        <term><command>mariadb-dump</command></term>
        <listitem>
          <para>
            is a backup program
          </para>
          <indexterm zone="mariadb mariadb-dump-mariadb">
            <primary sortas="b-mariadb-dump-mariadb">mariadb-dump</primary>
          </indexterm>
        </listitem>
      </varlistentry>

      <varlistentry id="mariadb-dumpslow-mariadb">
        <term><command>mariadb-dumpslow</command></term>
        <listitem>
          <para>
            parses MySQL slow query log files and prints a summary of their
            contents
          </para>
          <indexterm zone="mariadb mariadb-dumpslow-mariadb">
            <primary sortas="b-mariadb-dumpslow-mariadb">mariadb-dumpslow</primary>
          </indexterm>
        </listitem>
      </varlistentry>

     <varlistentry id="mariadb-embedded-mariadb">
        <term><command>mariadb-embedded</command></term>
        <listitem>
          <para>
            is a MySQL client statically linked to
            libmariadbd
          </para>
          <indexterm zone="mariadb mariadb-embedded-mariadb">
            <primary sortas="b-mariadbd-embedded-mariadb">mariadbd-embedded</primary>
          </indexterm>
        </listitem>
      </varlistentry>

      <varlistentry id="mariadb-find-rows-mariadb">
        <term><command>mariadb-find-rows</command></term>
        <listitem>
          <para>
            reads files containing SQL statements and extracts statements that
            match a given regular expression or that contain USE db_name or
            SET statements
          </para>
          <indexterm zone="mariadb mariadb-find-rows-mariadb">
            <primary sortas="b-mariadb-find-rows-mariadb">mariadb-find-rows</primary>
          </indexterm>
        </listitem>
      </varlistentry>

      <varlistentry id="mariadb-fix-extensions-mariadb">
        <term><command>mariadb-fix-extensions</command></term>
        <listitem>
          <para>
            converts the extensions for MyISAM (or ISAM) table files to
            their canonical forms
          </para>
          <indexterm zone="mariadb mariadb-fix-extensions-mariadb">
            <primary sortas="b-mariadb-fix-extensions-mariadb">mariadb-fix-extensions</primary>
          </indexterm>
        </listitem>
      </varlistentry>

      <varlistentry id="mariadb-hotcopy-mariadb">
        <term><command>mariadb-hotcopy</command></term>
        <listitem>
          <para>
            locks the table, flushes the table and then performs a copy of
            the database
          </para>
          <indexterm zone="mariadb mariadb-hotcopy-mariadb">
            <primary sortas="b-mariadb-hotcopy-mariadb">mariadb-hotcopy</primary>
          </indexterm>
        </listitem>
      </varlistentry>

      <varlistentry id="mariadb-import-mariadb">
        <term><command>mariadb-import</command></term>
        <listitem>
          <para>
            reads a range of data formats, and inserts the data into a
            database
          </para>
          <indexterm zone="mariadb mariadb-import-mariadb">
            <primary sortas="b-mariadb-import-mariadb">mariadb-import</primary>
          </indexterm>
        </listitem>
      </varlistentry>

      <varlistentry id="mariadb-install-db-mariadb">
        <term><command>mariadb-install-db</command></term>
        <listitem>
          <para>
            initializes the MySQL data directory and creates the system
            tables that it contains, if they do not exist
          </para>
          <indexterm zone="mariadb mariadb-install-db-mariadb">
            <primary sortas="b-mariadb-install-db-mariadb">mariadb-install-db</primary>
          </indexterm>
        </listitem>
      </varlistentry>

      <varlistentry id="mariadb-ldb-mariadb">
        <term><command>mariadb-ldb</command></term>
        <listitem>
          <para>
            is the RocksDB tool
          </para>
          <indexterm zone="mariadb mariadb-ldb-mariadb">
            <primary sortas="b-mariadb-ldb-mariadb">mariadb-ldb</primary>
          </indexterm>
        </listitem>
      </varlistentry>

      <varlistentry id="mariadb-plugin-mariadb">
        <term><command>mariadb-plugin</command></term>
        <listitem>
          <para>
            is a utility that enables MySQL administrators to manage which
            plugins a MySQL server loads
          </para>
          <indexterm zone="mariadb mariadb-plugin-mariadb">
            <primary sortas="b-mariadb-plugin-mariadb">mariadb-plugin</primary>
          </indexterm>
        </listitem>
      </varlistentry>

      <varlistentry id="mariadb-secure-installation-mariadb">
        <term><command>mariadb-secure-installation</command></term>
        <listitem>
          <para>
            is a tool to improve MySQL installation security
          </para>
          <indexterm zone="mariadb mariadb-secure-installation-mariadb">
            <primary sortas="b-mariadb-secure-installation-mariadb">mariadb-secure-installation</primary>
          </indexterm>
        </listitem>
      </varlistentry>

      <varlistentry id="mariadb-service-convert-mariadb">
        <term><command>mariadb-service-convert</command></term>
        <listitem>
          <para>
            generates a systemd unit based on the current mariadb settings
          </para>
          <indexterm zone="mariadb mariadb-service-convert-mariadb">
            <primary sortas="b-mariadb-service-convert-mariadb">mariadb-service-convert</primary>
          </indexterm>
        </listitem>
      </varlistentry>

      <varlistentry id="mariadb-setpermission-mariadb">
        <term><command>mariadb-setpermission</command></term>
        <listitem>
          <para>
            sets permissions in the MySQL grant tables
          </para>
          <indexterm zone="mariadb mariadb-setpermission-mariadb">
            <primary sortas="b-mariadb-setpermission-mariadb">mariadb-setpermission</primary>
          </indexterm>
        </listitem>
      </varlistentry>

      <varlistentry id="mariadb-show-mariadb">
        <term><command>mariadb-show</command></term>
        <listitem>
          <para>
            shows the structure of a MariaDB database
          </para>
          <indexterm zone="mariadb mariadb-show-mariadb">
            <primary sortas="b-mariadb-show-mariadb">mariadb-show</primary>
          </indexterm>
        </listitem>
      </varlistentry>

      <varlistentry id="mariadb-slap-mariadb">
        <term><command>mariadb-slap</command></term>
        <listitem>
          <para>
            is a diagnostic program designed to emulate client load for a
            MySQL server and to report the timing of each stage
          </para>
          <indexterm zone="mariadb mariadb-slap-mariadb">
            <primary sortas="b-mariadb-slap-mariadb">mariadb-slap</primary>
          </indexterm>
        </listitem>
      </varlistentry>

      <varlistentry id="mariadb-test-mariadb">
        <term><command>mariadb-test</command></term>
        <listitem>
          <para>
            runs a test case against a MySQL server and optionally compares
            the output with a result file
          </para>
          <indexterm zone="mariadb mariadb-test-mariadb">
            <primary sortas="b-mariadb-test-mariadb">mariadb-test</primary>
          </indexterm>
        </listitem>
      </varlistentry>

      <varlistentry id="mariadb-test-embedded-mariadb">
        <term><command>mariadb-test-embedded</command></term>
        <listitem>
          <para>
            is similar to the <command>mariadb-test</command> command but is built
            with support for the libmariadbd embedded server
          </para>
          <indexterm zone="mariadb mariadb-test-embedded-mariadb">
            <primary sortas="b-mariadb-test-embedded-mariadb">mariadb-test-embedded</primary>
          </indexterm>
        </listitem>
      </varlistentry>

      <varlistentry id="mariadb-tzinfo-to-sql-mariadb">
        <term><command>mariadb-tzinfo-to-sql</command></term>
        <listitem>
          <para>
            loads the time zone tables in the mariadb database
          </para>
          <indexterm zone="mariadb mariadb-tzinfo-to-sql-mariadb">
            <primary sortas="b-mariadb-tzinfo-to-sql-mariadb">mariadb-tzinfo-to-sql</primary>
          </indexterm>
        </listitem>
      </varlistentry>

      <varlistentry id="mariadb-upgrade-mariadb">
        <term><command>mariadb-upgrade</command></term>
        <listitem>
          <para>
            examines all tables in all databases for incompatibilities with
            the current version of MySQL Server
          </para>
          <indexterm zone="mariadb mariadb-upgrade-mariadb">
            <primary sortas="b-mariadb-upgrade-mariadb">mariadb-upgrade</primary>
          </indexterm>
        </listitem>
      </varlistentry>

      <varlistentry id="mariadb-waitpid-mariadb">
        <term><command>mariadb-waitpid</command></term>
        <listitem>
          <para>
            signals a process to terminate and waits for the process to exit
          </para>
          <indexterm zone="mariadb mariadb-waitpid-mariadb">
            <primary sortas="b-mariadb-waitpid-mariadb">mariadb-waitpid</primary>
          </indexterm>
        </listitem>
      </varlistentry>

      <varlistentry id="mariadb_config-mariadb">
        <term><command>mariadb_config</command></term>
        <listitem>
          <para>
            gets compiler flags for using the MariaDB Connector/C
          </para>
          <indexterm zone="mariadb mariadb_config-mariadb">
            <primary sortas="b-mariadb_config-mariadb">mariadb_config</primary>
          </indexterm>
        </listitem>
      </varlistentry>

      <varlistentry id="mbstream-mariadb">
        <term><command>mbstream</command></term>
        <listitem>
          <para>
            is an utility for sending InnoDB and XTraDB backups over a stream
          </para>
          <indexterm zone="mariadb mbstream-mariadb">
            <primary sortas="b-mbstream-mariadb">mbstream</primary>
          </indexterm>
        </listitem>
      </varlistentry>

      <varlistentry id="msql2mysql-mariadb">
        <term><command>msql2mysql</command></term>
        <listitem>
          <para>
            is a tool to convert mSQL programs for use with MySQL
          </para>
          <indexterm zone="mariadb msql2mysql-mariadb">
            <primary sortas="b-msql2mysql-mariadb">msql2mysql</primary>
          </indexterm>
        </listitem>
      </varlistentry>

      <varlistentry id="my_print_defaults-mariadb">
        <term><command>my_print_defaults</command></term>
        <listitem>
          <para>
            displays the options from option groups of option files
          </para>
          <indexterm zone="mariadb my_print_defaults-mariadb">
            <primary sortas="b-my_print_defaults-mariadb">my_print_defaults</primary>
          </indexterm>
        </listitem>
      </varlistentry>

      <varlistentry id="myisam_ftdump-mariadb">
        <term><command>myisam_ftdump</command></term>
        <listitem>
          <para>
            displays information about FULLTEXT indexes in MyISAM tables
          </para>
          <indexterm zone="mariadb myisam_ftdump-mariadb">
            <primary sortas="b-myisam_ftdump-mariadb">myisam_ftdump</primary>
          </indexterm>
        </listitem>
      </varlistentry>

      <varlistentry id="myisamchk-mariadb">
        <term><command>myisamchk</command></term>
        <listitem>
          <para>
            gets information about your database tables or checks, repairs,
            or optimizes them
          </para>
          <indexterm zone="mariadb myisamchk-mariadb">
            <primary sortas="b-myisamchk-mariadb">myisamchk</primary>
          </indexterm>
        </listitem>
      </varlistentry>

      <varlistentry id="myisamlog-mariadb">
        <term><command>myisamlog</command></term>
        <listitem>
          <para>
            displays MyISAM log file contents
          </para>
          <indexterm zone="mariadb myisamlog-mariadb">
            <primary sortas="b-myisamlog-mariadb">myisamlog</primary>
          </indexterm>
        </listitem>
      </varlistentry>

      <varlistentry id="myisampack-mariadb">
        <term><command>myisampack</command></term>
        <listitem>
          <para>
            is a tool for compressing MyISAM tables
          </para>
          <indexterm zone="mariadb myisampack-mariadb">
            <primary sortas="b-myisampack-mariadb">myisampack</primary>
          </indexterm>
        </listitem>
      </varlistentry>

      <varlistentry id="mysql_config-mariadb">
        <term><command>mysql_config</command></term>
        <listitem>
          <para>
            provides you with useful information for compiling your MySQL
            client and connecting it to MySQL
          </para>
          <indexterm zone="mariadb mysql_config-mariadb">
            <primary sortas="b-mysql_config-mariadb">mysql_config</primary>
          </indexterm>
        </listitem>
      </varlistentry>

      <varlistentry id="mytop-mariadb">
        <term><command>mytop</command></term>
        <listitem>
          <para>
            is a console-based tool for monitoring the threads and overall
            performance of a MySQL server
          </para>
          <indexterm zone="mariadb mytop-mariadb">
            <primary sortas="b-mytop-mariadb">mytop</primary>
          </indexterm>
        </listitem>
      </varlistentry>

      <varlistentry id="perror-mariadb">
        <term><command>perror</command></term>
        <listitem>
          <para>
            is a utility that displays descriptions for system or storage
            engine error codes
          </para>
          <indexterm zone="mariadb perror-mariadb">
            <primary sortas="b-perror-mariadb">perror</primary>
          </indexterm>
        </listitem>
      </varlistentry>

      <varlistentry id="replace-mariadb">
        <term><command>replace</command></term>
        <listitem>
          <para>
            is a MariaDB/MySQL extension to the SQL standard
          </para>
          <indexterm zone="mariadb replace-mariadb">
            <primary sortas="b-replace-mariadb">replace</primary>
          </indexterm>
        </listitem>
      </varlistentry>

      <varlistentry id="resolve_stack_dump-mariadb">
        <term><command>resolve_stack_dump</command></term>
        <listitem>
          <para>
            resolves a numeric stack dump to symbols
          </para>
          <indexterm zone="mariadb resolve_stack_dump-mariadb">
            <primary sortas="b-resolve_stack_dump-mariadb">resolve_stack_dump</primary>
          </indexterm>
        </listitem>
      </varlistentry>

      <varlistentry id="resolveip-mariadb">
        <term><command>resolveip</command></term>
        <listitem>
          <para>
            is a utility for resolving IP addresses to host names and
            vice versa
          </para>
          <indexterm zone="mariadb resolveip-mariadb">
            <primary sortas="b-resolveip-mariadb">resolveip</primary>
          </indexterm>
        </listitem>
      </varlistentry>

      <varlistentry id="sst_sump-mariadb">
        <term><command>sst_sump</command></term>
        <listitem>
          <para>
            dumps the content of sst files (the format used by RocksDB)
          </para>
          <indexterm zone="mariadb sst_sump-mariadb">
            <primary sortas="b-sst_sump-mariadb">sst_sump</primary>
          </indexterm>
        </listitem>
      </varlistentry>

    </variablelist>

  </sect2>

</sect1>
